<template>
  <v-layout column>
    <v-flex xs12>
      <h1>Планирование</h1>
    </v-flex>
    <v-tabs grow class="elevation-5">
      <v-tabs-slider></v-tabs-slider>

      <v-tab href="#tab-Provisions" v-if="this.isManager">
        Планирование
      </v-tab>
      <v-tab-item value="tab-Provisions" class="pa-2">
        <v-flex xs12>
          <v-card class="elevation-3 pa-2">
            <v-btn color="primary" @click.stop="addProvision">
              <v-icon>{{ icons.plus }}</v-icon
              >&nbsp;Добавить позицию
            </v-btn>
          </v-card>
        </v-flex>
        <v-flex xs12 class="my-2">
          <Provisions
            :provisions="provisions"
            v-on:delete-provision="onDeleteProvision"
          />
        </v-flex>
        <v-dialog persistent v-model="dialogProvision" max-width="500px">
          <Provision
            v-on:cancel-provision="onCancelProvision"
            v-on:save-provision="onSaveProvision"
          />
        </v-dialog>
      </v-tab-item>

      <v-tab href="#tab-Statistics">
        Статистика
      </v-tab>
      <v-tab-item value="tab-Statistics" class="pa-2">
        <v-flex xs12>
          <v-card class="elevation-3 pa-2">
            <excel
              name="statistics.xls"
              :fields="excelFields"
              :data="currentStatistics"
            >
              <v-btn color="primary">
                <v-icon>{{ icons.export }}</v-icon
                >&nbsp;Экспорт в Excel
              </v-btn>
            </excel>
          </v-card>
        </v-flex>
        <v-flex xs12 md6 class="my-1">
          <!-- <v-container>
            <v-layout row align-center> -->
          <!-- <v-flex xs12 md6 class="my-1 px-1">
                <v-card class="elevation-3 px-2">
                  <v-autocomplete
                    clearable
                    height="49"
                    color="secondary"
                    label="Пункт доставки"
                    v-model.trim="currentPointId"
                    :items="points"
                    item-text="address"
                    item-value="pointId"
                  ></v-autocomplete>
                </v-card>
              </v-flex> -->
          <!-- <v-flex xs12 md6 class="my-1 px-1"> -->
          <DateRange
            v-on:start-date-changed="onStatisticsStartDateChanged"
            v-on:end-date-changed="onStatisticsEndDateChanged"
          />
          <!-- </v-flex>
            </v-layout>
          </v-container> -->
        </v-flex>
        <v-flex xs12 class="my-2">
          <Statistics
            :statistics="statistics"
            v-on:filtered-statistics="onFilteredStatistics"
          />
        </v-flex>
      </v-tab-item>
    </v-tabs>
  </v-layout>
</template>

<script>
import { mapState, mapActions } from "vuex";

import { Icon } from "@/helpers";
import { Role } from "@/helpers";

const Provisions = () => import("@/components/Provision/Provisions");
const Provision = () => import("@/components/Provision/Provision");
const Statistics = () => import("@/components/Provision/Statistics");
const DateRange = () => import("@/components/_common/DateRange");

export default {
  components: {
    Provisions,
    Provision,
    Statistics,
    DateRange,
  },
  computed: {
    ...mapState({
      user: (state) => state.users.user,
      provisions: (state) => state.provisions.provisions,
      points: (state) => state.points.points,
      statistics: (state) => state.provisions.statistics,
    }),
    isManager: function () {
      return this.user.userRoles
        ? this.user.userRoles.includes(Role.Manager)
        : false;
    },
    excelFields: function () {
      return {
        "Адрес доставки": "pointAddress",
        Производитель: "manufacturer",
        Наименование: "productName",
        "План, РОЦ": "provisionPrice",
        "План, шт": "provisionQuantity",
        "Факт закупок, РОЦ": "orderPrice",
        "Факт закупок, шт": "orderQuantity",
        "% выполнения плана, РОЦ": "progressPrice",
        "% выполнения плана, шт": "progressQuantity",
        "Дата начала": {
          field: "start",
          callback: (value) => {
            return `${this.$dayjs(String(value)).format("DD.MM.YYYY")}`;
          },
        },
        "Дата завершения": {
          field: "end",
          callback: (value) => {
            return `${this.$dayjs(String(value)).format("DD.MM.YYYY")}`;
          },
        },
      };
    },
  },
  methods: {
    ...mapActions({
      getUser: "users/GET_USER",
      getProvisions: "provisions/GET_PROVISIONS",
      createProvision: "provisions/ADD_PROVISION",
      deleteProvision: "provisions/REMOVE_PROVISION",
      getPoints: "points/GET_POINTS",
      getStatistics: "provisions/GET_STATISTICS",
    }),
    addProvision: function () {
      this.dialogProvision = true;
    },
    onCancelProvision: function () {
      this.dialogProvision = false;
    },
    onSaveProvision: async function (item) {
      await this.createProvision(item);
      this.dialogProvision = false;
      await this.getProvisions();
      await this.getStatistics({
        userId: this.user.userId,
        start: this.dates.start,
        end: this.dates.end,
      });
    },
    onDeleteProvision: async function (provisionId) {
      await this.deleteProvision(provisionId);
      await this.getProvisions();
      await this.getStatistics({
        userId: this.user.userId,
        start: this.dates.start,
        end: this.dates.end,
      });
    },
    onStatisticsStartDateChanged: async function (date) {
      this.dates.start = date;
      await this.getStatistics({
        userId: this.user.userId,
        start: this.dates.start,
        end: this.dates.end,
      });
    },
    onStatisticsEndDateChanged: async function (date) {
      this.dates.end = date;
      await this.getStatistics({
        userId: this.user.userId,
        start: this.dates.start,
        end: this.dates.end,
      });
    },
    onFilteredStatistics: async function (items) {
      this.currentStatistics = items;
    },
  },
  watch: {
    currentPointId: async function (value) {
      await this.getStatistics({
        userId: this.user.userId,
        start: this.dates.start,
        end: this.dates.end,
        pointId: value,
      });
    },
  },
  data: () => ({
    dialogProvision: false,
    dates: {
      start: "",
      end: "",
    },
    currentPointId: "",
    icons: {
      plus: Icon.plus,
      export: Icon.export,
    },
    currentStatistics: [],
  }),
  mounted: async function () {
    await this.getUser();
    if (this.isManager) await this.getProvisions();
    await this.getPoints(this.user.userId);
    await this.getStatistics({ userId: this.user.userId });
  },
};
</script>
